extends Node

const GAMEPATH = "/root/game/"

var players = {}

signal connected_to_server
signal connection_failed
signal server_disconnected


func joinServer(ip, port):
	# Create the network client
	var peer_join:NetworkedMultiplayerENet = NetworkedMultiplayerENet.new()
	peer_join.create_client(ip, int(port))
	get_tree().set_network_peer(peer_join)
	
	print("Trying to join the server ", ip, ":", port, " with id: ", get_tree().get_network_unique_id()) 


puppet func registerPlayer(id): 
	players[id] = str(id)
	print("Player add, id: ", id) 


puppet func removePlayer(id):
	players.erase(id)
	if has_node(GAMEPATH+str(id)):
		get_node(GAMEPATH+str(id)).queue_free()
	
	print("Player ", str(id), " removed")


puppet func startGame():
	print("The server has started the game (you lost btw)")
	print("players: ", players.values())

	get_node("/root/lobby").hide()
	
	var game:Node = preload("res://levels/test/game.tscn").instance()
	var player_scene:PackedScene = preload("res://entities/characters/player.tscn")
	get_tree().get_root().add_child(game)
	
	# TODO: check (and perhaps) the scene changing functionality
	# get_tree().change_scene("res://scenes/levels/game/game.tscn")

	#Next evey player will spa every other player including the server's own client! Try to move this to server only 
	var i = 1
	for peer_id in players:
		var player:Node = player_scene.instance()
		
		player.set_name(str(peer_id))
		get_node(GAMEPATH).add_child(player)
			
		
		var spawnPosition:Vector3 = get_node("/root/game/spawnCollection/spawn"+str(i)).get_translation()
		player.translate(spawnPosition)
		
		i+=1
		
	var playerArrow:Node = preload("res://entities/characters/playerArrow.tscn").instance()
	get_node(GAMEPATH+str(get_tree().get_network_unique_id())).add_child(playerArrow)